;; Joe Wells code

(defvar sml-type-error-slicer-program-directory "")

(require 'cl)

;; *** need better name ***
(defface sml-tes-standard-error-focus
  '((((class color) (background dark))
     (:background "#9b0000"))
    (t (:background "#ff8e8e")))
  "Used to highlight a section of code that contributes to the type error when the error is in focus.")


;; *** need better name ***
(defface sml-tes-standard-error-non-focus
  '((((class color) (background dark))
     (:background "#500000"))
    (t (:background "#ffe5e5")))
  "Used to highlight a section of code that contributes to the type error when the error is not in focus.")

(defface sml-tes-standard-box-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#9b0000" :style nil)))
    (t (:box
	(:line-width 2 :color "#ff8e8e" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not (when the error is in focus).")

(defface sml-tes-standard-box-non-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#500000" :style nil)))
    (t (:box
	(:line-width 2 :color "#ffe5e5" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not (when the error is not in focus).")

(defface sml-tes-standard-error-head-focus
  '((((class color) (background dark))
     (:background "#9b0000" :foreground "white" :weight extra-bold))
    (t (:background "#ff8e8e" :foreground "white" :weight extra-bold)))
  "*********************************************")

(defface sml-tes-end-point-one-focus
  '((((class color) (background dark))
     (:background "Blue"))
    (t (:background "#9999ff")))
  "Used to highlight a section of code that is an end point of a type constructor clash, an arity clash, or a record clash (in focus).")

(defface sml-tes-end-point-one-non-focus
  '((((class color) (background dark))
     (:background "#000050"))
    (t (:background "#dfdffb")))
  "Used to highlight a section of code that is an end point of a type constructor clash, an arity clash, or a record clash (not in focus).")

(defface sml-tes-end-point-one-box-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "Blue" :style nil)))
    (t (:box
	(:line-width 2 :color "#9999ff" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not. This region identified by the box is an end point of a clash (when the error is in focus).")

(defface sml-tes-end-point-one-box-non-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#000050" :style nil)))
    (t (:box
	(:line-width 2 :color "#dfdffb" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not. This region identified by the box is an end point of a clash (when the error is not in focus).")

(defface sml-tes-end-point-one-head-focus
  '((((class color) (background dark))
     (:background "Blue" :foreground "white" :weight extra-bold))
    (t (:background "#9999ff" :foreground "white" :weight extra-bold)))
  "********************************************")

(defface sml-tes-end-point-two-focus
  '((((class color) (background dark))
     (:background "#898989"))
    (t (:background "grey")))
  "Used to highlight a section of code that is an end point of a type constructor clash, an arity clash, or a record clash (in focus).")

(defface sml-tes-end-point-two-non-focus
  '((((class color) (background dark))
     (:background "#404040"))
    (t (:background "#e3e3e3")))
  "Used to highlight a section of code that is an end point of a type constructor clash, an arity clash, or a record clash (not in focus).")

(defface sml-tes-end-point-two-box-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#898989" :style nil)))
    (t (:box
	(:line-width 2 :color "grey" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not. This region identified by the box is an end point of a clash (when the error is in focus).")

(defface sml-tes-end-point-two-box-non-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#404040" :style nil)))
    (t (:box
	(:line-width 2 :color "#e3e3e3" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not. This region identified by the box is an end point of a clash (when the error is not in focus).")

(defface sml-tes-end-point-two-head-focus
  '((((class color) (background dark))
     (:background "#898989" :foreground "white" :weight extra-bold))
    (t (:background "grey" :foreground "white" :weight extra-bold)))
  "**********************************************")

(defface sml-tes-merged-regions-focus
  '((((class color) (background dark))
     (:background "ForestGreen"))
    (t (:background "green")))
  "Used to highlight a section of code that is an end point a record clash (in focus). The highlited text appears in both clashing records.")

(defface sml-tes-merged-regions-non-focus
  '((((class color) (background dark))
     (:background "#004000"))
    (t (:background "#e0ffe0")))
  "Used to highlight a section of code that is an end point record clash (not in focus). The highlited text appears in both clashing records.")

;; *** need better name ***
(defface sml-tes-further-explanations-focus
  '((((class color) (background dark))
     (:background "DarkMagenta"))
    (t (:background "plum")))
  "Used to highlight code provides information about the status of identifiers or that is expansive (in focus).")

;; *** need better name ***
(defface sml-tes-further-explanations-non-focus
  '((((class color) (background dark))
     (:background "#500050"))
    (t (:background "#f9dbfb")))
  "Used to highlight code provides information about the status of identifiers or that is expansive (not in focus).")


(defface sml-tes-further-explanations-box-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "DarkMagenta" :style nil)))
    (t (:box
	(:line-width 2 :color "plum" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not (when the error is in focus).")

(defface sml-tes-further-explanations-box-non-focus
  '((((class color) (background dark))
     (:box
      (:line-width 2 :color "#500050" :style nil)))
    (t (:box
	(:line-width 2 :color "#f9dbfb" :style nil))))
  "Used to surround an piece of code for which the presence is relevevant to the error but the contents are not (when the error is not in focus).")

(defface sml-tes-parsing-error-focus
  '((((class color) (background dark))
     (:background "yellow"))
    (t (:background "yellow")))
  "Used to highlight the regions of code that cannot be parsed by the type error slicer.")

(defface sml-tes-parsing-error-non-focus
  '((((class color) (background dark))
     (:background "#FDFDB2"))
    (t (:background "#FDFDB2")))
  "Used to highlight the regions of code that cannot be parsed by the type error slicer.")

;; Variable to keep track of the number of times the slicer has been run
(defvar sml-tes-count 0)

(defvar sml-tes-fake-lines 0)

;; Variable to keep track of the number of errors found by the slicer
(defvar sml-tes-item-count 0)

;; Variable to keep track of the number of errors processed
(defvar sml-tes-error-count 1)

;; The time limit that the slicer is allowed to run
(defvar sml-tes-timelimit 60000)

;; *** fix to use expand-file-name and test
(defvar sml-tes-basis-file (concat sml-type-error-slicer-program-directory "/basis.sml"))

;; sml
;; (defvar sml-tes-sml-process "/home/vince/Work/smlnj-11070/bin/sml")
(defvar sml-tes-sml-process "sml")

;; the option concerning the use of the basis
;; 0: no basis
;; 1: buildin environment
;; 2: basis filesx
(defvar sml-tes-basis-option 2)

;; Variable to flag whether or not the interface is ready to process another error
(defvar sml-tes-ready t)

;; Variable to flag when the user wishes to have the verbose error messages displayed
(defvar sml-tes-verbose-error-messages t)

;;(defvar sml-tes-slices-processed-mark)
;;
;;(put 'sml-tes-slices-processed-mark 'permanent-local t)

;; WTF are we doing this for?
(defvar error nil)

;; Variable to hold the list of slices found by the slicer
(defvar sml-tes-slices nil)

;; Variable to hold the list of slices found by the slicer that have been viewed by the user
(defvar sml-tes-slices-previous nil)

;; Variable to hold the list of overlays that are used to highlight sections of the source file
(defvar sml-tes-overlays nil)

;; Variable to keep track of the current file that is being sliced
(defvar sml-tes-file-being-sliced nil)

;; Variable to point to the current slice
(defvar sml-tes-current-slice-pointer nil)

(defvar sml-tes-current-slice-not-viewed nil)

;; Advice that allows the properties of tooltips to be manipulated so
;; that the error messages are displayed properly
(defadvice tooltip-show (around fix-stupid-face-idiocy activate)
  (let ((tooltip-show-original-text (ad-get-arg 0)))
    ad-do-it))

;; Advice that allows the properties of tooltips to be manipulated so
;; that the error messages are displayed properly
(defadvice x-show-tip (before fix-stupid-face-idiocy activate)
  (if (boundp 'tooltip-show-original-text)
      (ad-set-arg 0 tooltip-show-original-text))
  )

(defun sml-tes-run-slicer ()
  "Runs the type error slicer using the 'commslicerp' command available from the Slicer.
   This function runs the type error slicer through the SML sources.
   This function can be used by developers of the type error slicer so that they can run
   the slicer without the need to produce a binary executbale of the slicer each time they
   update the slicer."
  (interactive)
  ;; Set sml-tes-error-sount to 1 as the slicer produces files numbered 1,2,...
  (setq sml-tes-error-count 1)
  (setq sml-tes-need-to-abandon nil)
  ;; Increase the variable that keeps track of the number of times the slicer has been run
  ;; since this file was loaded. This variable is used in the name of the process that runs
  ;; the slicer, allowing for multiple slicer processes
  (setq sml-tes-count (1+ sml-tes-count))
  ;; Keep track of the the file being sliced
  (setq sml-tes-file-being-sliced (buffer-file-name))
  (save-window-excursion
    ;; Set up the command to run the slicer
    (let ((file-dir-and-path (sml-tes-dir sml-tes-file-being-sliced))
	  (make-command (format "echo 'CM.make \"%s\"; "
				(expand-file-name "sources.cm"
						  sml-type-error-slicer-program-directory)))
	  (open-command "open Slicer; ")
	  (run-command (format "commslicerp \"%s\" [\"%s\"] \"\" \"\" \"\" \"" sml-tes-basis-file sml-tes-file-being-sliced))
	  (output-file nil)
	  (output-dir nil)
	  (rest-command (format "\" \"\" %d %d;' | %s" sml-tes-basis-option sml-tes-timelimit sml-tes-sml-process))
	  (timer nil))
      (setq output-dir (format "%s-slices/" (car (cdr file-dir-and-path))))
      (setq output-file (concat (car file-dir-and-path) (format "%s%s.el" output-dir (car (cdr file-dir-and-path)))))
      ;; Format the command
      (setq sml-tes-command (concat make-command open-command run-command output-file rest-command))
      ;; Remove all of the error information in the current file
      (sml-tes-forget-all-slices)
      ;; Create a temporary directory to store the output from the slicer
      (shell-command (format "mkdir %s" output-dir))
      ;; Run the slicer
      (sml-tes-trace "RUNNING SLICER")
      (start-process-shell-command (format "sml-tes-%d" sml-tes-count) nil sml-tes-command)
      ;; Set the time that the tooltip error messages are shown
      (setq tooltip-hide-delay 20)
      ;; Process the errors
      (sml-tes-process-errors))))

(defun sml-tes-run-slicer-exec ()
  "Runs the type error slicer using a stable executable of the slicer."
  (interactive)
  ;; Set sml-tes-error-sount to 1 as the slicer produces files numbered 1,2,...
  (setq sml-tes-error-count 1)
  ;; Keep track of the the file being sliced
  (setq sml-tes-file-being-sliced (buffer-file-name))
  (save-window-excursion
    ;; Set up the command to run the slicer
    (let ((file-dir-and-path (sml-tes-dir sml-tes-file-being-sliced))
	  (run-command (format "%s/bin/slicer \"%s\" \"%s\" \"\" \"\" \"\" \"" sml-type-error-slicer-program-directory sml-tes-basis-file sml-tes-file-being-sliced))
	  (output-file nil)
	  (timer nil))
      (setq output-dir (format "%s-slices/" (car (cdr file-dir-and-path))))
      (setq output-file (concat (car file-dir-and-path) (format "%s%s.el" output-dir (car (cdr file-dir-and-path)))))
      ;; Remove all of the error information in the current file
      (sml-tes-forget-all-slices)
      ;; Create a temporary directory to store the output from the slicer
      ;; *** use make-directory instead
      (shell-command (format "mkdir %s" output-dir))
      ;; Run the slicer
      (sml-tes-trace "RUNNING SLICER")
      (start-process-shell-command (format "sml-tes-%d" sml-tes-count) nil(concat run-command output-file "\" \"\""))
      ;; Set the time that the tooltip error messages are shown
      (setq tooltip-hide-delay 20)
      ;; Process the errors
      (sml-tes-process-errors))))

(defun sml-tes-dir (str)
  "This function takes in a filepath of a file and returns the filepath of the containing
   folder and the name of the file"
  (let ((string "/")
	;; Split the full filepath everwhere there is a "/"
	(split (split-string str "/")))
    ;; Loop through the list of the split file path to produce the file path of the directory
    (while (cdr split)
      (setq string (concat string (car split)  "/"))
      (setq split (cdr split)))
    ;; Return a list of the file path and file name
    (cons string (last split))))

(defun sml-tes-process-errors ()
  "This function processes the output files produced by the type error slicer"
  ;; Get the file path to the containing directory and the file name of the file being sliced
  (let ((file-dir-and-path (sml-tes-dir sml-tes-file-being-sliced))
	(output-file nil))
    ;; Create the name of the output files
    (setq output-file (format "%s%s-slices/%s-%d.el" (car file-dir-and-path) (car (cdr file-dir-and-path)) (car (cdr file-dir-and-path)) sml-tes-error-count))
    ;; If the file indicating the slicer has finished exists ([filename-finished].el), and there are no other error files to be processed then ...
    (if (and (file-exists-p (format "%s%s-slices/%s-finished.el" (car file-dir-and-path) (car (cdr file-dir-and-path)) (car (cdr file-dir-and-path))))
	     (not (file-exists-p (format "%s%s-slices/%s-%d.el" (car file-dir-and-path)  (car (cdr file-dir-and-path)) (car (cdr file-dir-and-path)) sml-tes-error-count))))
	(progn
	  ;; ... Remove all of the temporary files produced by the slicer ...
          ;; *** Eeek!  Running rm -rf is dangerous!!!
	  (shell-command (format "rm -rf %s%s-slices"(car file-dir-and-path) (car (cdr file-dir-and-path))))
	  (sml-tes-trace "SLICING FINISHED"))
      ;; ... else when there are no slices currently getting processed
      ;; and the next error file exists, then process the next error
      (if (and (file-exists-p output-file) sml-tes-ready)
	  (progn
	    (load-file output-file)
	    (if (buffer-modified-p (get-file-buffer sml-tes-file-being-sliced))
		(progn
                  ;; *** Eeek!  Running rm -rf is dangerous!!!
		  (shell-command (format "rm -rf %s%s-slices"(car file-dir-and-path) (car (cdr file-dir-and-path))))
		  (sml-tes-trace "BUFFER MODIFIFED - SLICING STOPPED"))
	      ;; Process the error
	      (sml-tes-process-error-file error)
	      ;; Remove the error file that has just been processed
	      (shell-command (format "rm %s "output-file))
	      (sml-tes-trace "SEARCHING FOR OUTPUT")
	      ;; Increment the counter that keeps track of the next error
	      (setq sml-tes-error-count (1+ sml-tes-error-count))
	      (setq sml-tes-current-slice-pointer (butlast sml-tes-slices))
	      ;; The next error is ready so process it
	      (sml-tes-process-errors)))
	;; Still waiting on the slicer, so wait a bit before trying again
	(run-at-time 1 nil 'sml-tes-process-errors)
	))))

;; > Pour Lucy (Louis) XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
(defun show-constraints ()
  "Highlight constraints"
  (interactive)
  (let ((file (concat (file-name-sans-extension (buffer-file-name))
                            ".el"))
	(sml-tes-file-being-sliced buffer-file-name))
    (load-file file)
    (sml-tes-process-error-file error)
    )
  )
;; < Pour Lucy (Louis) XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

(defun sml-tes-process-error-file (list)
  "Processes the information in the file containing the details of the error"
  ;; Set the flag "sml-tes-ready" to show that an error is currently being processed
  (let ((sml-tes-ready nil) ;; can the timer really run during this function?
        (count 0))
    ;; Keep track of the number of errors in the file
    ;; ** Should only ever be 1 error per file, but the function allows for more (just incase) **
    (setq sml-tes-item-count (safe-length list))
    ;; While there are to process
    (while (<= count (safe-length list))
      (let ((item (nth count list)))
	;; Identify the different parts of the error
	(let* ((id          (cdr (assoc 'id item)))
	       (regs        (cdr (assoc 'regions item)))
	       (slice       (cdr (assoc 'slice item)))
	       (assumptions (cdr (assoc 'assumptions item)))
	       (kind        (cdr (assoc 'kind item)))
	       (remove      (cdr (assoc 'remove item))))
	  ;; Highlight the slice
          ;; *** pass these as separate arguments!!!
	  (sml-tes-highlight-slice (cons regs (cons (sml-tes-format-slice-info slice assumptions kind) (cons id nil))))
	  ;; Some slices may require some other slices to be removed (slices that are two or more minimal slices merged)
	  (when (not (equal 0 (safe-length remove)))
	    ;; Remove all of the slices that are no longer needed
	    (while remove
	      (sml-tes-forget-slice-by-id (car remove))
	      (setq remove (cdr remove))))
	  ))
      ;; Increment the counter "count" so that the next error will be processed
      (setq count (1+ count))))
  )

;; (defun sml-tes-highlight-slice (args)
;;   "Highlights a slice - a slice is made up of a number of regions"
;;   (sml-tes-trace "HIGHLIGHTING A SLICE ENTER [%s]" (car (cddr args)))
;;   ;; Identify the different parts of the error
;;   (let ((formattedRegs nil)
;; 	(regs  (car args))
;; 	(slice (car (cdr args)))
;; 	(id    (car (cddr args)))
;; 	(myovs nil))
;;     (while regs
;;       (let* ((file (caar regs))
;; 	     (regions (cdr (assoc file regs))))
;; 	(find-file file)
;; 	;; Put the information into a form in which it is easily processed
;; 	(setq slice (car (cdr args)))
;; 	(setq slice (cons id (cons (car slice) (cons (cons (car (cdr slice)) (cons (sml-tes-contains-box regions) nil)) nil))))
;; 	(setq formattedRegs nil)
;; 	(setq formattedRegs (mapslice formattedRegs regions slice))
;; 	;; Highlight the regions
;; 	(let ((ovs
;; 	       (apply #'append
;; 		      (mapcar #'sml-tes-highlight-region formattedRegs))))
;; 	  (mapc
;; 	   (lambda (ov) (overlay-put ov 'sml-tes-slice ovs))
;; 	   ovs)
;; 	  (setq myovs (append myovs ovs)))
;; 	(setq regs (cdr regs))
;; 	)
;;       )
;;     ;; Keep track of the error slices
;;     (when (not sml-tes-slices)
;;       (push nil sml-tes-slices))
;;     (when (not (equal myovs nil))
;;       (push (reverse myovs) sml-tes-slices))
;;     )
;;   (sml-tes-trace "HIGHLIGHTING A SLICE EXIT"))

(defun sml-tes-highlight-slice (args)
  "Highlights a slice - a slice is made up of a number of regions"
  (sml-tes-trace "HIGHLIGHTING A SLICE ENTER [%s]" (car (cddr args)))
  ;; Identify the different parts of the error
  (let ((formattedRegs nil)
	(regs  (car args))
	(slice (car (cdr args))) ;; *** why is this repeated below???
	(id    (car (cddr args)))
	(myovs nil))
    (while regs
      (let* ((file    (caar (last regs))) ;; *** why processing last item first???
	     (regions (cdr (assoc file regs))))
        (with-current-buffer (find-file-noselect file)
          ;; Put the information into a form in which it is easily processed
          (setq slice (car (cdr args)))
          (setq slice (cons id (cons (car slice) (cons (cons (car (cdr slice)) (cons (sml-tes-contains-box regions) nil)) nil))))
          (setq formattedRegs nil)
          (setq formattedRegs (mapslice formattedRegs regions slice))
          ;; Highlight the regions
          (let ((ovs
                 (apply #'append
                        (mapcar #'sml-tes-highlight-region formattedRegs))))
            (mapc
             (lambda (ov) (overlay-put ov 'sml-tes-slice ovs))
             ovs)
            (setq myovs (append myovs ovs)))
          ;;	(setq regs (cdr regs))
          (setq regs (butlast regs))
          ))
      )
    ;; Keep track of the error slices
    (when (not sml-tes-slices)
      (push nil sml-tes-slices))
    (when (not (equal myovs nil))
      (push (reverse myovs) sml-tes-slices))
    )
  (sml-tes-trace "HIGHLIGHTING A SLICE EXIT"))


(defun sml-tes-is-box (reg)
  "test is a regions is a box"
  (let ((ret nil))
    (case (car reg)
      ;; If the error code is "N" then it is a box
      (N (setq ret t)))
    ret))

(defun sml-tes-contains-box (regs)
  "search through a list of regions to determine if there is a box"
  (let ((ret "NOBOX"))
    (while regs
      (when (sml-tes-is-box (car regs))
	(setq ret "BOX"))
      (setq regs (cdr regs)))
    ret))

(defun mapslice (regs mylist slice)
  "format the list of regions mylist into regs: from ((reg1) (reg2) ...) to ((reg1 slice) (reg2 slice) ..).
  slice is more than slices, it contains extra information"
  (while mylist
    (push (cons (car mylist) (cons slice nil)) regs)
    (setq mylist (cdr mylist))
    )
  regs
  )

;; *** MAY NEED TO ADD BUFFER AS EN EXTRA INPUT PARAMTER
(defun sml-tes-line-and-char-to-buf-and-pos (line char)
  "Transforms a line number and column number into a buffer and the position that (line, char) is in the buffer"
  (prog1
      (let (file)
	(cond ((<= line sml-tes-fake-lines)
	       (setq file 'fake))
	      (t
	       (setq file 'main)
	       (setq line (- line sml-tes-fake-lines))))
	(save-excursion
	  (set-buffer
	   (case file
	     (fake (get-buffer-create sml-tes-fake-buffer))
	     (main (current-buffer))))
	  ;;	     (main (find-file-noselect sml-tes-file-being-sliced))))
	  (save-excursion
	    (goto-char (point-min))
	    (forward-line (1- line))
	    (condition-case nil
		(forward-char (1- char))
	      (error nil))
	    (cons (current-buffer)
		  (point)))))
    ))


(defun sml-tes-highlight-region (args)
  "Highlights a region"
  (let ((reg   (car args))
	(id    (car (car (cdr args))))
	(slice (car (cdr (car (cdr args)))))
	(info  (car (cdr (cdr (car (cdr args)))))))
    (set-text-properties 0 (length slice) nil slice)
    (font-lock-append-text-property 0 (length slice) 'face '(:family "fixed") slice)
    (prog1
	(destructuring-bind (type (bline bchar eline echar) color . subitems) reg
	  (let* ((buf-and-pos-beg
		  (sml-tes-line-and-char-to-buf-and-pos bline bchar))
		 (beg (cdr buf-and-pos-beg))
		 (buf-and-pos-end
		  (sml-tes-line-and-char-to-buf-and-pos eline echar))
		 (end (cdr buf-and-pos-end))
		 (buf (car buf-and-pos-beg))
		 (ov (make-overlay
		      beg
		      (1+ end)
		      (car buf-and-pos-beg)
		      t nil)))
	    (or (eq buf (car buf-and-pos-end))
		(error "impossible"))
	    ;; Add the overlay to the list of overlays
	    (push ov sml-tes-overlays)
	    ;; Add the necessary information to the properties of the overlays
	    (overlay-put ov 'sml-tes-type type)
	    (overlay-put ov 'sml-tes-id id)
	    (overlay-put ov 'sml-tes-info slice)
	    (overlay-put ov 'sml-tes-color color)
	    (sml-tes-set-overlay-properties ov nil)
	    ;; Calculate and store the inforamtion for the more detailed information
	    ;; ***LINE BELOW CAUSES THE PROGRAM TO BE A LOT SLOWER
	    (overlay-put ov 'sml-tes-more-info (sml-tes-find-info info))
	    ;; If the user wishes to have the verbose error messages shown, then show them
	    ;; otherwise show the non verbose error messages
	    (if sml-tes-verbose-error-messages
		(overlay-put ov 'help-echo (concat (overlay-get ov 'sml-tes-info) (overlay-get ov 'sml-tes-more-info)))
	      (overlay-put ov 'help-echo (overlay-get ov 'sml-tes-info)))
	    (overlay-put ov 'evaporate t)
	    (cons ov
		  (when subitems
		    (apply #'append
			   (mapcar #'sml-tes-highlight-region
				   (mapslice nil (car subitems) (cons id (cons slice (cons info nil)))))))))
	  )
      )))

(defun sml-tes-set-overlay-properties (ov focus)
  "Sets the properties of the overlays that make up the highlighting of the regions of the slices"
  (let* ((color (overlay-get ov 'sml-tes-color))
	 (message-first-part (overlay-get ov 'sml-tes-info))
	 (message-second-part (overlay-get ov 'sml-tes-more-info)))

    ;; If the overlay is in focus display the information about the error
    ;; otherwise display no information
    (if (equal t focus)
	(progn
	  (when sml-tes-verbose-error-messages
	    (setq message-first-part (concat message-first-part message-second-part)))
	  (overlay-put ov 'help-echo message-first-part))
      (overlay-put ov 'help-echo nil))
    (overlay-put ov 'sml-tes-focus focus)
    (overlay-put ov 'face
		 (case (overlay-get ov 'sml-tes-type)
		   (L (case color
			((R) (if focus 'sml-tes-standard-error-focus 'sml-tes-standard-error-non-focus))
			((B) (if focus 'sml-tes-end-point-one-focus 'sml-tes-end-point-one-non-focus))
			((P) (if focus 'sml-tes-end-point-two-focus 'sml-tes-end-point-two-non-focus))
			((G) (if focus 'sml-tes-merged-regions-focus 'sml-tes-merged-regions-non-focus))
			((O) (if focus 'sml-tes-further-explanations-focus 'sml-tes-further-explanations-non-focus))
			((Y) (if focus 'sml-tes-parsing-error-focus 'sml-tes-parsing-error-non-focus))
			))
		   (H (case color
			((R) (if focus 'sml-tes-standard-error-head-focus 'sml-tes-standard-error-non-focus))
			((B) (if focus 'sml-tes-end-point-one-head-focus 'sml-tes-end-point-one-non-focus))
			((P) (if focus 'sml-tes-end-point-two-head-focus 'sml-tes-end-point-two-non-focus))
			))
		   (N (case color
			((R) (if focus 'sml-tes-standard-box-focus 'sml-tes-standard-box-non-focus))
			((B) (if focus 'sml-tes-end-point-one-box-focus 'sml-tes-end-point-one-box-non-focus))
			((P) (if focus 'sml-tes-end-point-two-box-focus 'sml-tes-end-point-two-box-non-focus))
			((O) (if focus 'sml-tes-further-explanations-box-focus 'sml-tes-further-explanations-box-non-focus))
			))
		   (t (error "impossible"))))
    (overlay-put ov 'priority
		 (case color
		   ((B G O P)
		    (if focus 4 2))
		   ((R Y)
		    (if focus 3 1))))))

(defun sml-tes-format-slice-info (slice assumptions kind)
  "Formats the details of the error for displaying to the user"
  ;; Report the appropriate mesage for the number of context dependencies in the error
  ;; 0 context dependencies
  (if (equal '0 (safe-length assumptions))
      (cons (concat "Error: " (car (cdr kind)) "\n\nSlice:\n" slice) (cons (car kind) nil))
    ;; 1 context dependency
    (if (equal '1 (safe-length assumptions))
	(cons (concat "Error: " (car (cdr kind)) "\n\nContext Dependency: " (prin1-to-string (car assumptions)) " is neither a datatype nor an exception constructor\n\nSlice: " slice)(cons (car kind) nil))
      ;; 2 or more context dependencies
      (let ((dependencies ""))
	(while (> (safe-length assumptions) 0)
	  (setq dependencies (concat dependencies (prin1-to-string (pop assumptions)) ", ")))
	(cons (concat "Error: " (car (cdr kind)) "\n\nContext Dependencies: " (substring dependencies 0 (- (length dependencies) 2))  " are neither datatype\nnor exception construcotrs\n\nSlice: " slice) (cons (car kind) nil)))))
  )

(defun sml-tes-find-info (info)
  "Calculates the extra details of the error messages that are used for the verbose error messages"
  ;; Determine the different details of the error
  (let ((kind (car info))
	(box  (car (cdr info)))
	(legendItems nil))
    ;; If the slice contains a box, add box to the list of items that need to be displayed in the legend
    (when (equal "BOX" box)
      (push 5 legendItems))
    ;; Add the extra infomation depending on the kind of error - retrieve the approprite items that need to be displayed in the legend
    (case kind
;;> Louis
;      ((CST) (push 4 legendItems) (push 1 legendItems) (push 0 legendItems) ("\n\nAdditional info: Unable to solve constrainte system"))
      ((CST) (push 4 legendItems) (push 1 legendItems) (push 0 legendItems) (concat  "\n\nAdditional info: Unable to solve constrainte system" (sml-tes-get-legend legendItems)))
;;< Louis
      ((TYP) (push 4 legendItems) (push 1 legendItems) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when two type constructors are constrained to be equal\nbut are not, for example int = bool" (sml-tes-get-legend legendItems)))
      ((ARI) (push 4 legendItems) (push 1 legendItems) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when a sequence of length N is constrained to be of\nlength N where M is not equal to N" (sml-tes-get-legend legendItems)))
      ((REC) (push 4 legendItems) (push 2 legendItems) (push 1 legendItems) (push 0 legendItems)(concat   "\n\nAdditional info: Occurs when two two records are constrained to be equal but a\nlabel appears in one record and does not appear in the other" (sml-tes-get-legend legendItems)))
      ((CIR) (push 4 legendItems) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when a type is ocnstrained to contain itself\n(an infinite type)" (sml-tes-get-legend legendItems)))
      ((INC) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when there is a free type variable in a datatype\nor type declaration" (sml-tes-get-legend legendItems)))
      ((MUL) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when an identifier is bound more than once in one\ndeclaration" (sml-tes-get-legend legendItems)))
      ((VAL) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when a value variable is supplied an argument in a\npattern" (sml-tes-get-legend legendItems)))
      ((FUN) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when a function is declared with two differing names" (sml-tes-get-legend legendItems)))
      ((FRE) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when there is a type variable in the top level\nenviroment that is not bound to anything (free)" (sml-tes-get-legend legendItems)))
      ((LAS) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when the identifier on teh left of an \"as\" is not a\nvalue variable" (sml-tes-get-legend legendItems)))
      ((APP) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when an identifier is both applied and not applied to\nan argument inside a pattern" (sml-tes-get-legend legendItems)))
      ((ARG) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when a function is defined to take an\ninconsistent nuber of arguments" (sml-tes-get-legend legendItems)))
      ((UNG) (push 0 legendItems) (concat  "\n\nAdditional info: Occurs when SML does not allow generalisation of type variables at certain value declarations" (sml-tes-get-legend legendItems)))
      ((UNM) (push 4 legendItems) (push 2 legendItems) (push 1 legendItems) (push 0 legendItems) (concat "\n\nAdditional info: Occurs when a structure does not declare an identifier that\nit is supposed to" (sml-tes-get-legend legendItems)))
      ((PAR) (push 3 legendItems) (concat  "\n\nAdditional info: Please refer to the details above" (sml-tes-get-legend legendItems)))
      ((FNE) (push 0 legendItems) (concat  "\n\nAdditional info: Expressions with recursive value must be functions" (sml-tes-get-legend legendItems)))
      ((REA) (push 0 legendItems) (concat  "\n\nAdditional info: A real cannot occurs within a pattern" (sml-tes-get-legend legendItems)))
      ((IDE) (push 3 legendItems) (concat  "\n\nAdditional info: Free identifier" (sml-tes-get-legend legendItems)))
      )
    )
  )

(defun sml-tes-get-legend (items)
  "Produces the legend that contains the items 'items' (a list that is taken in as a paramater)"
  (let ((legend "\n\nLEGEND:\n"))
    ;; For each item needed, retrieve the appropriate inforamtion
    (while items
      (setq legend (concat legend (sml-tes-get-legend-info (car items))))
      (setq items (cdr items)))
    ;; Return the legend
    legend))

(defun sml-tes-get-legend-info (item)
  "Returns the approprite legend item for 'item' (the paramater of the function)"
  (let ((red    "RED")
	(grey   "GRAY")
	(blue   "BLUE")
	(green  "GREEN")
	(purple "PURPLE")
	(yellow "YELLOW")
	(box    "BOX")
	(indent "\n\t   "))
    ;; Add the appropriate details for 'item' (the paramater of the function)
    (case item
      ((0) (concat (propertize red    'face 'sml-tes-standard-error-focus) ": Indicates that the highlighted text contributes to the error.\n"))
      ((1) (concat (propertize grey   'face 'sml-tes-end-point-two-focus) "/" (propertize blue 'face 'sml-tes-end-point-one-focus) ": Indicates that the highlighted text is an end point of a type\nconstructor clash, an arity clash or a record clash.\n"))
      ((2) (concat (propertize green  'face 'sml-tes-merged-regions-focus) ": Indicates the endpoint of a record clash. The highlighted text appears\nin both clashing records.\n" ))
      ((3) (concat (propertize yellow 'face 'sml-tes-parsing-error-focus) ": Indicates that either;" indent "1. The file contains a syntax error," indent "2. The file contains a feature of SML not yet handled by the type" indent "   error slicer," indent "3. The highlighted file is not a valid \".sml\" or \".tes\" file, or" indent "4. The highlighted file does not exit.\n"))
      ((4) (concat (propertize purple 'face 'sml-tes-further-explanations-focus) ": Indicates that the highlighted code provides information about the\nstatus of an identifier or that the code is expansive.\n"))
      ((5) (concat (propertize box    'face '(:box (:line-width 2 :color t :style nil)))": Can indicate:\n\t1: The application of a function to an argument (the contents of the" indent "box) takes part in an error. It is usually convenient to surround" indent "the argument of a function when the application participates in the" indent "error,or\n\t2: The contents of the box are the unique argument of a type name to" indent "make explicit that its arity is 1 (that is, has one argument). This" indent "is because there is no section of code to highlight, making explicit" indent "when its arity is 1 .\n" ))
      )))

(defun sml-tes-next-slice ()
  "Highlights the next slice in the list"
  (interactive)
  ;; If the current slicer pointer is non nil
  (if sml-tes-current-slice-pointer
      (progn
	;; If there is a next slice
	(if (car sml-tes-current-slice-pointer)
	    (progn
	      ;; Add the first item of the current slice pointer to the end of the list
	      (setq sml-tes-current-slice-pointer (append sml-tes-current-slice-pointer (cons (car sml-tes-current-slice-pointer) nil)))
	      ;; Set current slice pointer to be the tail of itself
	      (setq sml-tes-current-slice-pointer (cdr sml-tes-current-slice-pointer))
	      ;; Set the next slice to be in focus
	      (sml-tes-focus-slice (car sml-tes-current-slice-pointer))
	      ;; Set the parts of the slice that have not been viewed to be the whole slice
	      (setq sml-tes-current-slice-not-viewed (car sml-tes-current-slice-pointer))
	      ;; Focus on the begining of the slice
	      (sml-tes-focus-next-part-of-slice (car sml-tes-current-slice-pointer)))
	  ;; The current slice pointer is nil, set it to point to all of the slices
	  ;; and unfocus all of the slices.
	  (sml-tes-unfocus-all-slices)
	  (setq sml-tes-current-slice-pointer (append sml-tes-current-slice-pointer (cons (car sml-tes-current-slice-pointer) nil)))
	  (setq sml-tes-current-slice-pointer (cdr sml-tes-current-slice-pointer))
	  ))
    ;; The current slice pointer is nil, set it to point to all of the slices
    ;; and unfocus all of the slices.
    (setq sml-tes-current-slice-pointer (butlast sml-tes-slices))
    (sml-tes-unfocus-all-slices)))

(defun sml-tes-prev-slice ()
  "Highlights the next slice in the list"
  (interactive)
  ;; If the current slicer pointer is non nil
  (let ((last (last sml-tes-current-slice-pointer)))
    (if last
	;; If there is a previous slice
	(if (car last)
	    (progn
	      ;; Set the previous slice to be in focus
	      (sml-tes-focus-slice (car last))
	      ;; Set the parts of the slice that have not been viewed to be the whole slice
	      (setq sml-tes-current-slice-not-viewed (car last))
	      ;; Focus on the begining of the slice
;;	      (sml-tes-next-part-of-slice)
	      (sml-tes-focus-next-part-of-slice (car sml-tes-current-slice-pointer))
	      ;; Remove the last slice from the list that current slice pointer points to
	      (setq sml-tes-current-slice-pointer (butlast sml-tes-current-slice-pointer))
	      ;; Add the last slice to the begining of the list that current slice pointer points to
	      (push (car last) sml-tes-current-slice-pointer))
	  ;; The current slice pointer is nil, set it to point to all of the slices
	  ;; and unfocus all of the slices.
	  (sml-tes-unfocus-all-slices)
	  (setq sml-tes-current-slice-pointer (butlast sml-tes-current-slice-pointer))
	  (push (car last) sml-tes-current-slice-pointer))
    ;; The current slice pointer is nil, set it to point to all of the slices
    ;; and unfocus all of the slices.
    (setq sml-tes-current-slice-pointer (butlast sml-tes-slices))
    (sml-tes-unfocus-all-slices))))

(defun sml-tes-overlay-in-view (overlay)
  "Tests whether or not the overlay is in view"
  (let ((ov-start (overlay-start overlay))
	(ov-end (overlay-end overlay)))
    ;; If the buffer of the overlay is not currently in view ...
    (if (not (get-buffer-window (overlay-buffer overlay)))
	;; ... then the overlay is in view, so return nil ...
	nil
      ;; ... otherwise, if the whole of the overlay is in view ...
      (if (and (pos-visible-in-window-p ov-start) (pos-visible-in-window-p ov-end))
	  ;; ... return true ...
	  t
	;; ... otherwise return nil
	nil
	))))

(defun sml-tes-next-part-of-slice ()
  "Displays the next part of the slice that is not currently in view"
  (interactive)
  (let ((list sml-tes-current-slice-not-viewed))
    (setq sml-tes-current-slice-not-viewed nil)
    ;; If all parts of the current slice have been viewed
    ;; then set the list that contains the overlays which
    ;; have yet to be viewed to contain all of the overlays
    ;; in the current slice
    (when (not list)
      (setq sml-tes-current-slice-not-viewed (car sml-tes-current-slice-pointer))
      (sml-tes-next-part-of-slice)
      )
    ;; Foucs the next part of the current slice which is not currently visible
    (sml-tes-focus-next-part-of-slice list)
    ;; Update the list of the overlays in the current slice which have yet to be viewed
    (while list
      (when (not (sml-tes-overlay-in-view (car list)))
	(setq sml-tes-current-slice-not-viewed (append sml-tes-current-slice-not-viewed (cons (car list) nil)))
	)
      (setq list (cdr list))
      )
    )
  )

(defun sml-tes-focus-next-part-of-slice (list)
  "Focuses on the next part of the current slice which is not currently visible"
  (when (car list)
    ;; When the next overlay has no buffer (i.e. the buffer has been killed)...
    (if (not (overlay-buffer (car list)))
	(progn
	  (let ((old-slice-pointer sml-tes-current-slice-pointer))
	    ;; tidy up the list of slices so that it does not contain overlays which
	    ;; exist in buffers which do not exist
	    (sml-tes-tidy-slices)
	    )
	  )
      (let ((overlay (car list)))
	;; Set the selected window to show the buffer that contains the overlay
	(if (not (get-buffer-window (overlay-buffer overlay)))
	    (switch-to-buffer (overlay-buffer overlay))
	  (select-window (get-buffer-window (overlay-buffer overlay)))
	  )
	;; Set the window start position to be the same as the start position of the overlay
	(set-window-start (get-buffer-window (overlay-buffer overlay)) (overlay-start overlay))
	;; Set the window point position to be the 1 point to the left of the start position of the overlay
	(set-window-point (get-buffer-window (overlay-buffer overlay)) (- (overlay-start overlay) 1))
	(let ((line (what-line)))
	  ;; Parse the integer value from the output of the "what-line" command
	  (setq line (string-to-number (substring line 5 (length line))))
	  ;; Set the window start position to be the same as the begining of the line on which the overlay starts
	  (set-window-start (get-buffer-window (overlay-buffer overlay)) (cdr (sml-tes-line-and-char-to-buf-and-pos line 0)))
;;todel	  (set-window-point (get-buffer-window (overlay-buffer overlay)) (cdr (sml-tes-line-and-char-to-buf-and-pos line 0)))
	  )
	)
      )
    )
  )

(defun sml-tes-skip-past-word-if-in-one ()
  (when (and (not (bobp))
             (save-excursion
               (backward-char)
               (looking-at "[A-Za-z0-9_'][A-Za-z0-9_']")))
    (skip-chars-forward "A-Za-z0-9_'")
    (if (looking-at "\\s-")
        (forward-char))))

(defun sml-tes-backward-to-dec ()
  (interactive)
  (sml-tes-skip-past-word-if-in-one)
  (while (and (re-search-backward
               "[A-Za-z0-9_']"
               nil
               'move)
              (skip-chars-backward "[A-Za-z0-9_']")
              (not (looking-at "\\(datatype\\|eqtype\\|exception\\|structure\\|type\\|val\\)\\s-")))))

(defun sml-tes-forward-to-dec ()
  (interactive)
  (if (re-search-forward "[^A-Za-z0-9_']\\(datatype\\|eqtype\\|exception\\|structure\\|type\\|val\\) " nil 'move)
      (goto-char (1+ (match-beginning 0)))))

(defun sml-tes-alist-put (sym key val)
  (let ((item (assoc key (symbol-value sym))))
    (if item
        (setcdr item val)
      (push (cons key val) (symbol-value sym)))))

(defun sml-tes-alist-get (sym key)
  (cdr (assoc key (symbol-value sym))))

(defun sml-tes-display-slice-as-much-as-possible (ovs)
  (interactive (list (car sml-tes-current-slice-pointer)))
  (let (bufs earliests latests overlays)
    (dolist (ov ovs)
      (let* ((buf (overlay-buffer ov))
             (old-earliest (sml-tes-alist-get 'earliests buf))
             ;;(old-latest (sml-tes-alist-get 'latests buf))
             )
        (pushnew buf bufs)
        (sml-tes-alist-put 'overlays
                           buf
                           (adjoin ov
                                   (sml-tes-alist-get 'overlays buf)))
        (sml-tes-alist-put 'earliests buf
                           (if old-earliest
                               (min old-earliest
                                    (overlay-start ov))
                             (overlay-start ov)))
        ;;(sml-tes-alist-put 'latests buf
        ;;                   (if old-latest
        ;;                       (max old-latest
        ;;                            (overlay-end ov))
        ;;                     (overlay-end ov)))
        ))
    (delete-other-windows)
    (let ((wins (list (selected-window)))
          next-level-wins)
      (while (< (+ (length wins)
                   (length next-level-wins))
                (length bufs))
        (when (null wins)
          (setq wins (nreverse next-level-wins))
          (setq next-level-wins nil))
        (let ((new-win (split-window (car wins))))
          (push (pop wins) next-level-wins)
          (push new-win next-level-wins)))
      (setq wins (append (nreverse next-level-wins) wins))
      (dolist (buf bufs)
        (with-current-buffer buf
          (let ((is-basis
                 ;; *** don't test against the string "basis.sml".  do this right!
                 (equal "basis.sml" (file-name-nondirectory buffer-file-name)))
                (win (pop wins)))
            (set-window-buffer win buf)
            (set-window-start
             win
             (save-excursion
               (goto-char (sml-tes-alist-get 'earliests buf))
               (cond (is-basis
                      (forward-char 1)
                      (sml-tes-backward-to-dec))
                     (t
                      (beginning-of-line)))
               (point)))
            (when is-basis
              ;; *** instead of disabling undo, this should be done
              ;; with overlays instead of text properties.
              ;; *** Setting read only and disabling undo should be
              ;; done elsewhere.
              ;; *** read-only should be adjusted with let so it is
              ;; properly restored in case of abort.
              (setq buffer-read-only nil)
              (buffer-disable-undo)
              (put-text-property (point-min) (point-max) 'display nil)
              (goto-char (point-min))
              (let ((sorted-ovs
                     (sort (sml-tes-alist-get 'overlays buf)
                           (lambda (o1 o2)
                             (< (overlay-start o1)
                                (overlay-start o2))))))
                (while sorted-ovs
                  (let ((ov (pop sorted-ovs))
                        (pos (point)))
                    (goto-char (1+ (overlay-start ov)))
                    (sml-tes-backward-to-dec)
                    (put-text-property pos (point) 'display "\n")
                    (sml-tes-forward-to-dec)
                    (while (and sorted-ovs
                                (< (overlay-start (car sorted-ovs))
                                   (point)))
                      (pop sorted-ovs)))))
              (put-text-property (point) (point-max) 'display "\n")
              (setq buffer-read-only t)
              (set-buffer-modified-p nil)
              ;; (goto-char (1+ (sml-tes-alist-get 'earliests buf)))
              ;; ;;(put-text-property (point) (1+ (point)) 'display "•")
              ;; (sml-tes-backward-to-dec)
              ;; ;;(put-text-property (point) (1+ (point)) 'display "‣")
              ;; (put-text-property (point-min) (point) 'invisible t)
              ;; (goto-char (sml-tes-alist-get 'latests buf))
              ;; ;;(put-text-property (1- (point)) (point) 'display "◦")
              ;; (sml-tes-forward-to-dec)
              ;; ;;(put-text-property (1- (point)) (point) 'display "⁃")
              ;; (put-text-property (point) (point-max) 'invisible t)
              )))))))

(defun sml-tes-adjust-slice-focus (ovs focus)
  "Adjust the focus of the slice that is made up of the overlays 'ovs'"
  (mapc
   (lambda (ov) (sml-tes-set-overlay-properties ov focus))
   ovs))

(defun sml-tes-focus-slice (slice)
  "Sets the slice 'slice' to be in focus"
  (mapc
   (lambda (sl)
     (sml-tes-adjust-slice-focus
      sl
      (or (null slice)
	  (eq slice sl))))
   sml-tes-slices)
  ;; *** Maybe this call should not be here?:
  (sml-tes-display-slice-as-much-as-possible slice))

;; This function is not called at the present time
(defun sml-tes-print-error-message-buffer ()
  "Prints the error messages in the message buffer"
  (let ((error-message (overlay-get (caar sml-tes-current-slice-pointer) 'sml-tes-info))
	(error-message-extra-details (overlay-get (caar sml-tes-current-slice-pointer) 'sml-tes-more-info)))
    ;; Remove all of the text properties from the error messages
    (set-text-properties 0 (length error-message) nil error-message)
    (set-text-properties 0 (length error-message-extra-details) nil error-message-extra-details)
    ;; Print error message
    (print "****\tError Message (start)\t****")
    ;; If the user has the verbose error messgae option selected ...
    (if sml-tes-verbose-error-messages
	;; ... then print the verbose error messages ...
	(print (concat error-message error-message-extra-details))
      ;; ... otherwise print the shortened error message
      (print error-message))
    (print "****\tError Message (end)\t****")
    ))

(defun sml-tes-unfocus-all-slices ()
  "Sets all of the slices to be out of focus"
  (mapc
   (lambda (sl)
     (sml-tes-adjust-slice-focus
      sl
      nil))
   sml-tes-slices))


(defun sml-tes-forget-all-slices ()
  "Removes all of the details about all of the slices"
  (interactive)
  (sml-tes-trace "FORGETTING ENTER")
  (while sml-tes-overlays
    (delete-overlay (pop sml-tes-overlays)))
  (setq sml-tes-slices nil)
  (setq sml-tes-current-slice-pointer nil))

(defun sml-tes-forget-all-slices-file ()
  "Removes all of the details about all of the slices in the current file"
  (interactive)
  ;; Set pointer to be an exact copy of sml-tes-overlays
  (let ((pointer sml-tes-overlays)
	(buffer (current-buffer)))
    ;; Set sml-tes-overlays to be nil
    (setq sml-tes-overlays '())
    ;; While we have not looked at all of the overlays
    (while (car pointer)
      ;; If the overlay we are looking at is in the current buffer delete it...
      (if (equal (overlay-buffer (car pointer)) buffer)
	  (delete-overlay (car pointer))
	;; ...otherwise add it back to sml-tes-overlays
	(push (car pointer) sml-tes-overlays))
      ;; Increment the pointer to look at the next slice
      (setq pointer (cdr pointer)))
    ;; If all of the slices we in this buffer, then...
    (if (equal 0 (safe-length sml-tes-overlays))
	(progn
	  ;; Set the pointer to the current slice to nil
	  (setq sml-tes-current-slice-pointer nil)
	  ;; Set the list of Slices to nil
	  (setq sml-tes-slices nil)))
    ;; Tidy up the slcies
    (sml-tes-tidy-slices)))

(defun sml-tes-forget-slice-by-id (id)
  "Removes the slice with id 'id'. Used to remove slices when they are no longer needed
     i.e. when the slicer merges 2 or more slices"
  ;; Set pointer to be an exact copy of sml-tes-overlays
  (let ((pointer sml-tes-overlays))
    ;; Set sml-tes-overlays to be nil
    (setq sml-tes-overlays '())
    ;; While we have not looked at all of the overlays
    (while (car pointer)
      ;; If the current overlay is in the slice with id 'id' delete it...
      (if (equal id (overlay-get (car pointer) 'sml-tes-id))
	  (delete-overlay (car pointer))
	;; ...otherwise add it back to the list of overlays
	(push (car pointer) sml-tes-overlays))
      ;; Look at the next overlay in the list
      (setq pointer (cdr pointer)))
    ;; If all of the overlays were in the slice with id 'id'
    (if (equal 0 (safe-length sml-tes-overlays))
	(progn
	  ;; Set the pointer to the current slice to nil
	  (setq sml-tes-current-slice-pointer nil)
	  ;; Set the list of Slices to nil
	  (setq sml-tes-slices nil)))
    ;; Tidy up the slcies
    (sml-tes-tidy-slices)))

(defun sml-tes-tidy-slices ()
  "Ensures that the list of slices is tidy (there are no overlays that have been deleted)"
  ;; Set pointer to be an exact copy of sml-tes-slices
  (let ((pointer sml-tes-slices))
    ;; Set sml-tes-slices to be nil
    (setq sml-tes-slices nil)
    ;; Add 'nil' to the beginning of the list
    (push nil sml-tes-slices)
    ;; While we have not looked at all of the slices
    (while (car pointer)
      ;; When the current slice has not been deleted (exists in a buffer) add it back to sml-tes-slices
      (when (not (equal (overlay-buffer (caar pointer)) nil))
	(push (car pointer) sml-tes-slices))
      ;; Increment the pointer to look at the next slice
      (setq pointer (cdr pointer))
      ))
  ;; Set the current-slice-pointer to point to the list of slices
  (setq sml-tes-current-slice-pointer (butlast sml-tes-slices)))

(defun sml-tes-trace (msg &rest data)
  "Writes a message and some data (optional) so that useful information can be displayed to the user"
  (apply #'message (concat "(SML-TES) " msg) data)
  (if (fboundp 'redisplay)
      (redisplay t)))

(defun sml-tes-set-timelimit (time)
  "Changes the time that the slicer is run for"
  (interactive "nnew time limit:")
  (setq sml-tes-timelimit time))

(defun sml-tes-set-basis-option (option)
  "Changes the basis option (0/1/2 as explained above)"
  (interactive "nnew basis option:")
  (setq sml-tes-basis-option option))

(defun sml-tes-toggle-verbose ()
  "Toggle whether or not the verbose error messages are shown"
  (interactive)
  (setq sml-tes-verbose-error-messages (not sml-tes-verbose-error-messages)))

(defun sml-tes-show-help ()
  "Loads and displays the help file for the Type Error Slicer"
  (interactive)
  (let* ((cur-window (selected-window))
	 (help-window (split-window cur-window nil)))
    (select-window help-window)
    (view-file (expand-file-name "EmacsUI/EMACS-HELP" sml-type-error-slicer-program-directory))
    )
  )
